import {QuestionMap} from "inquirer";
import inquirer from "inquirer";

export const prompt = inquirer.prompt;
export const registerPrompt = inquirer.registerPrompt;
export const Separator = inquirer.Separator;
export type InquireFunction<QuestionT extends QuestionMap[keyof QuestionMap], AnswerT extends QuestionT["default"]> = (question: QuestionT) => Promise<AnswerT>
export type ShowFunction = (text: string) => Promise<void>

export async function inquire<QuestionT extends QuestionMap[keyof QuestionMap], AnswerT extends QuestionT["default"]>(question: QuestionT): Promise<AnswerT> {
    const result = await prompt([{...question, name: "answer"}])
    return result.answer
}