export function merge<Update extends {readonly [key: string]: unknown}, Data extends Update>(update: Update, base: Data): Data {
    const data = {
        ...update,
        ...base,
    }
    // Purge keys that were intentionally removed...
    Object.keys(update).forEach((key: keyof typeof update) => {
        if (typeof update[key] === "undefined") {
            delete data[key]
        }
    })
    return data
}